﻿ -- OnShow
 function LockBoxConfigFrame_OnShow()
	-- read settings from profile, and change our checkbuttons and slider to represent them
	getglobal(this:GetName().."SliderOffset1"):SetValue(PlayerHealth*100);
	getglobal(this:GetName().."SliderOffset2"):SetValue(PlayerMana*100);
	getglobal(this:GetName().."SliderOffset3"):SetValue(ShardCount);
	getglobal(this:GetName().."SliderOffset4"):SetValue(DrainSoulLimit);
	getglobal("AlphaSlider"):SetValue(LB_PanelAlpha);
	--Set the spell string text values
	local I
	for I,line in ipairs(LB_SpellStringTbl) do
		getglobal(this:GetName().."SpellStringEditBox"..I):SetText(LB_SpellStringTbl[I]);
	end
	
	--Set the checked button
	getglobal("Spell1CheckButton"):SetChecked(0)
	getglobal("Spell2CheckButton"):SetChecked(0)
	getglobal("Spell3CheckButton"):SetChecked(0)
	getglobal("Spell4CheckButton"):SetChecked(0)
	getglobal("Spell"..LB_SpellIndex.."CheckButton"):SetChecked(1)
	
	
	--Set checkboxes
	if LockBoxDebug == 1 then
		DebugCheckButton:SetChecked(1)
	end	
	if LB_Humanoid == 1 then
		HumanoidCheckButton:SetChecked(1)
	end	
	if LB_UseHS == 1 then
		UseHSCheckButton:SetChecked(1)
	end	
	if LB_SicPet == 1 then
		AlwaysSicPetButton:SetChecked(1)
	end
	
 end


-- OnClick
function LockBoxConfigFrame_OnClick()

	-- read setting out of checkbox (or slider) and put into profile
    -- use this:GetName() to know which checkbox was hit.
	if ( this:GetName() == (this:GetParent():GetName().."SliderOffset1" ) ) then
		PlayerHealth = (this:GetValue()/100);
	elseif ( this:GetName() == (this:GetParent():GetName().."SliderOffset2" ) ) then
		PlayerMana = (this:GetValue()/100);
	elseif ( this:GetName() == (this:GetParent():GetName().."SliderOffset3" ) ) then
		ShardCount = this:GetValue();
	elseif ( this:GetName() == (this:GetParent():GetName().."SliderOffset4" ) ) then
		DrainSoulLimit = this:GetValue();
	end
 end


function LB_SpellString1_OnTextChange()
	LB_SpellStringTbl[1] = this:GetText();
	if LB_SpellIndex == 1 then
		LB_SpellString = LB_SpellStringTbl[1]
	end
	LBP_UpdateAlpha();
end

function LB_SpellString2_OnTextChange()
	LB_SpellStringTbl[2] = this:GetText();
	if LB_SpellIndex == 2 then
		LB_SpellString = LB_SpellStringTbl[2]
	end
	LBP_UpdateAlpha();
end

function LB_SpellString3_OnTextChange()
	LB_SpellStringTbl[3] = this:GetText();
	if LB_SpellIndex == 3 then
		LB_SpellString = LB_SpellStringTbl[3]
	end
	LBP_UpdateAlpha();
end

function LB_SpellString4_OnTextChange()
	LB_SpellStringTbl[4] = this:GetText();
	if LB_SpellIndex == 4 then
		LB_SpellString = LB_SpellStringTbl[4]
	end
	LBP_UpdateAlpha();
end


function LB_ChangeString()
	LB_Loopstop = 0
	if LB_SpellStringTbl[LB_SpellIndex] == "" then
		while LB_SpellStringTbl[LB_SpellIndex] == "" do
			LB_SpellIndex = LB_SpellIndex + 1
			if LB_SpellIndex >=5 then
				LB_SpellIndex = 1
			end
			LB_Loopstop = LB_Loopstop + 1
			if LB_Loopstop == 5 then
				LB_Locktools_TOS("All SpellStrings are empty!!")
				return
			end
		end
	end
	LB_SpellString = LB_SpellStringTbl[LB_SpellIndex];
	SStringLabel:SetText(LB_SpellString)
	SStringName:SetText("String Name: "..LB_String_Name[LB_SpellIndex])
	LB_Locktools_TOS("LockBox is now using Spell String #"..LB_SpellIndex.." ("..LB_String_Name[LB_SpellIndex]..")")

end

function LB_IncrementSS()
	LB_SpellIndex = LB_SpellIndex + 1
	if LB_SpellIndex >= 5 then
		LB_SpellIndex = 1
	end
	LB_ChangeString()
end

function LB_DecrimentSS()
	LB_SpellIndex = LB_SpellIndex - 1
	if LB_SpellIndex <= 0 then
		LB_SpellIndex = 4
	end
	LB_ChangeString()
end

function LB_SS1()
	LB_SpellIndex = 1
	LB_ChangeString()
end

function LB_SS2()
	LB_SpellIndex = 2
	LB_ChangeString()
end

function LB_SS3()
	LB_SpellIndex = 3
	LB_ChangeString()
end

function LB_SS4()
	LB_SpellIndex = 4
	LB_ChangeString()
end

--Sets the transparency of the LockBox Panel frame based on LBPAlpha
function LBP_UpdateAlpha()
	LockBoxPanel:SetAlpha(LB_PanelAlpha);
	--LB_Locktools_TOS(LBPAlpha)
end

---------------------------------------------------------------------
--           Tooltip Text Strings
---------------------------------------------------------------------


PlayerHealth_Text = "Adjust this slider to control when the HEAL function will start to cast Drain Life while in combat."
PlayerMana_Text = "Adjust this slider to control when the MANA function will start to cast Life Tap and Drain Mana while in combat."
ShardCount_Text = "Adjust this slider to control how many shards the SOUL function will attempt to keep in your bag."
DrainSoulLimit_Text = "Adjust this slider to control how much heath (in percent) your target has to be down to before the SOUL function will attempt to Drain Soul. This assumes you have less soulshards than the Shards slider."
Debug_Text = "This checkbox enables debug messages in the chat box."
Humanoid_Text = "Determines if the LockBox makes a target check for humanoid race on the MOB before hitting with Curse of Recklessness in the DIEU function"
UseHS_Text = "Determines if the HEAL function will utilize available healthstones while in combat."
CreateHS_Text = "Determines if the PETA function will attempt check to see if the pet is in combat before sending it in."

