﻿--
-- This is the core LockBox file where engine functions will go
--
DEFAULT_CHAT_FRAME:AddMessage("LockBoxEngine.lua loaded.",1,0,0);


function LB_SpellChecker(searchedspell)
	ACID = nil
	for id = 1, 180, 1 do 
		local spellName, subSpellName = GetSpellName(id, SpellBookFrame.bookType)
		if spellName and string.find(spellName, searchedspell, 1, true) then 
			ACID = id 
		end;
	end;
	if ACID ~= nil then
		return true
	else
		return false
	end
end


function LB_PanelFunct(funct)
	PanelFunct = "Last: "..funct
	LB_FunctName:SetText(PanelFunct);
end


function LockBoxAction()

	if LockBoxDebug == 1 then	
		LB_Locktools_TOS("New Cast Sequence...")
	end

	
	
	LB_SpellTable = {n=0}
	J = 1
	StrPos = 1
	
	LB_SpellString = string.upper(LB_SpellString)
	
	LB_StringLen = string.len(LB_SpellString)
	
	--for I = 1, (LB_StringLen / 5) do
	for I = 1, ((LB_StringLen+1)/5) do
		LB_SpellTable[J] =  string.sub (LB_SpellString, StrPos, StrPos+3)
		StrPos = StrPos + 5
		J = J+1
	end 
	
    for i,line in ipairs(LB_SpellTable) do
		if LockBoxDebug == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("("..LB_SpellTable[i]..")",0,1,0);
		end

		ActionTaken = 0
		if LB_SpellTable[i] == "PETA" and ActionTaken == 0 then
			LB_PETA();
		end

		if LB_SpellTable[i] == "SKIN" and ActionTaken == 0 then
			LB_SKIN();
		end
		
		if LB_SpellTable[i] == "HEAL" and ActionTaken == 0 then
			LB_HEAL();
		end
		
		if LB_SpellTable[i] == "MANA" and ActionTaken == 0 then
			LB_MANA();
		end
		
		if LB_SpellTable[i] == "LTAP" and ActionTaken == 0 then
			LB_LTAP();
		end
		
		if LB_SpellTable[i] == "WAND" and ActionTaken == 0 then
			LB_WAND();
		end
				
		if LB_SpellTable[i] == "CURS" and ActionTaken == 0 then
			LB_CURS();
		end
		
		if LB_SpellTable[i] == "MATT" and ActionTaken == 0 then
			LB_MATT();
		end
		
		if LB_SpellTable[i] == "IMMO" and ActionTaken == 0 then
			LB_IMMO();
		end
		
		if LB_SpellTable[i] == "SHBO" and ActionTaken == 0 then
			LB_SHBO();
		end
		
		if LB_SpellTable[i] == "COWK" and ActionTaken == 0 then
			LB_COWK();
		end	
		
		if LB_SpellTable[i] == "CORR" and ActionTaken == 0 then
			LB_CORR();
		end		
		
		if LB_SpellTable[i] == "COAG" and ActionTaken == 0 then
			LB_COAG();
		end	
		
		if LB_SpellTable[i] == "SOUL" and ActionTaken == 0 then
			LB_SOUL();
		end
		
		if LB_SpellTable[i] == "CORK" and ActionTaken == 0 then
			LB_CORK();
		end		
		
		if LB_SpellTable[i] == "PAIN" and ActionTaken == 0 then
			LB_PAIN();
		end
		
		if LB_SpellTable[i] == "AMPC" and ActionTaken == 0 then
			LB_AMPC();
		end
		
		if LB_SpellTable[i] == "BURN" and ActionTaken == 0 then
			LB_BURN();
		end
		
		if LB_SpellTable[i] == "NTFL" and ActionTaken == 0 then
			LB_NTFL();
		end		
		
		if LB_SpellTable[i] == "COTN" and ActionTaken == 0 then
			LB_COTN();
		end		
		
		if LB_SpellTable[i] == "COEX" and ActionTaken == 0 then
			LB_COEX();
		end		
		
		if LB_SpellTable[i] == "COEL" and ActionTaken == 0 then
			LB_COEL();
		end
		
		if LB_SpellTable[i] == "CNFL" and ActionTaken == 0 then
			LB_CNFL();
		end
		
		if LB_SpellTable[i] == "COIL" and ActionTaken == 0 then
			LB_COIL();
		end
		
		if LB_SpellTable[i] == "COSH" and ActionTaken == 0 then
			LB_COSH();
		end
		
		if LB_SpellTable[i] == "FIRE" and ActionTaken == 0 then
			LB_FIRE();
		end
			
		if LB_SpellTable[i] == "TOPS" and ActionTaken == 0 then
			LB_TOPS();
		end

		if LB_SpellTable[i] == "DIEU" and ActionTaken == 0 then
			LB_DIEU();
		end
		
		if LB_SpellTable[i] == "SIPH" and ActionTaken == 0 then
			LB_SIPH();
		end
		
		if LB_SpellTable[i] == "PACT" and ActionTaken == 0 then
			LB_PACT();
		end
		
		if LB_SpellTable[i] == "STAT" and ActionTaken == 0 then
			LB_STAT();
		end
		
		--If the string is broken then post it to the chat in an error message.
		--
		--  UPDATE THIS SECTION WHEN NEW FUNCTIONS ARE ADDED!
		--
	
		if ActionTaken == 0 then
			if LockBoxDebug == 1 then
				DEFAULT_CHAT_FRAME:AddMessage("Checking SpellString Fragment:"..LB_SpellTable[i],1,0,0);
			end
			
			if LB_SpellTable[i] ~= "PETA" and
			LB_SpellTable[i] ~= "SKIN" and
			LB_SpellTable[i] ~= "HEAL" and
			LB_SpellTable[i] ~= "MANA" and
			LB_SpellTable[i] ~= "WAND" and
			LB_SpellTable[i] ~= "CURS" and
			LB_SpellTable[i] ~= "MATT" and
			LB_SpellTable[i] ~= "IMMO" and
			LB_SpellTable[i] ~= "SHBO" and
			LB_SpellTable[i] ~= "COWK" and
			LB_SpellTable[i] ~= "CORR" and
			LB_SpellTable[i] ~= "LTAP" and
			LB_SpellTable[i] ~= "COAG" and
			LB_SpellTable[i] ~= "SOUL" and
			LB_SpellTable[i] ~= "CORK" and
			LB_SpellTable[i] ~= "DIEU" and
			LB_SpellTable[i] ~= "PAIN" and
			LB_SpellTable[i] ~= "AMPC" and
			LB_SpellTable[i] ~= "BURN" and
			LB_SpellTable[i] ~= "NTFL" and
			LB_SpellTable[i] ~= "COTN" and
			LB_SpellTable[i] ~= "COEX" and
			LB_SpellTable[i] ~= "COEL" and
			LB_SpellTable[i] ~= "CNFL" and
			LB_SpellTable[i] ~= "COIL" and
			LB_SpellTable[i] ~= "COSH" and
			LB_SpellTable[i] ~= "FIRE" and
			LB_SpellTable[i] ~= "TOPS" and
			LB_SpellTable[i] ~= "SIPH" and
			LB_SpellTable[i] ~= "STAT" and
			LB_SpellTable[i] ~= "PACT" then
			
				DEFAULT_CHAT_FRAME:AddMessage("No action taken on SpellString fragment: '"..LB_SpellTable[i].."'",1,0,0);
			end
		end

		if ActionTaken == 1 then 
			if LockBoxDebug == 1 then	
				DEFAULT_CHAT_FRAME:AddMessage("Next Press...",1,1,1);
			end
			break
		end
    end
end


function LB_PETA()
	if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Fetch, Fido!...",0,1,0);
	end
	
	if (UnitCanAttack("player", "target")) and UnitExists("pet") then
		if LB_SicPet == 0 then
			if not UnitExists("pettarget") then
				PetAttack();
				LB_PanelFunct("PETA");
			else
				--DEFAULT_CHAT_FRAME:AddMessage("She's got a target already.",1,0,0);
			end
		else
			PetAttack();
			LB_PanelFunct("PETA");
		end
	end
end



function LB_SKIN()
	if LockBoxDebug == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Checking Armor...",0,1,0);
	end
	if UnitLevel("player") >= 20 then
		setArmor();
	else
		setSkin();
	end
end

function LB_STAT()
	if LockBoxDebug == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Checking Stats...",0,1,0);
	end
	if UnitExists("target") then 
		if ((UnitHealth("player") / UnitHealthMax("player")) < .30 ) then
			LB_HEAL()
			LB_PanelFunct("STAT (Emergency Health)");
			return
		end
		if UnitMana("player") < UnitHealth("player") then 
			--DEFAULT_CHAT_FRAME:AddMessage("Mana"..UnitMana("player").." < Health"..UnitHealth("player").." so casting MANA...",0,1,0);
			LB_MANA()
			LB_PanelFunct("STAT (Mana)");
			return
		else
			--DEFAULT_CHAT_FRAME:AddMessage("Mana"..UnitMana("player").." > Health"..UnitHealth("player").." so casting HEAL...",0,1,0);
			LB_HEAL()
			LB_PanelFunct("STAT (Health)");
			return
		end
	end
end

function LB_HEAL()
	if LockBoxDebug == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Checking Health...",0,1,0);
	end

	
	--Check for healthstone and use if allowed
	if LB_UseHS == 1 then
		if LB_IsHealthStoneAvail() then
			if UnitExists("target") and ((UnitHealth("player") / UnitHealthMax("player")) < .25 ) then
				LB_UseHealthStone()
				LB_PanelFunct("HEAL (Healthstone)");
				return
			end
		end
	end
		
	if UnitLevel("player") >= 14 and UnitExists("target") then
		if (UnitHealth("player") / UnitHealthMax("player")) < PlayerHealth then
			CastSpellByName("Drain Life");
			LB_PanelFunct("HEAL (Drain Life)");
			ActionTaken = 1;
		end
	end
end



function LB_MANA()
	if LockBoxDebug == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Checking Mana...",0,1,0);
	end
	if UnitExists("target") then
		if (UnitMana("player") / UnitManaMax("player")) < PlayerMana then
			if LB_SpellChecker("Dark Pact") and UnitMana("pet") > 150 then
						CastSpellByName("Dark Pact");
						LB_PanelFunct("MANA (Dark Pact)");
						ActionTaken = 1;
			elseif LB_SpellChecker("Drain Mana") then
				if (UnitClass("target") =="Warrior" or UnitClass("target") =="Rogue") then
					if LB_SpellChecker("Life Tap") then
						CastSpellByName("Life Tap");
						LB_PanelFunct("MANA (Life Tap)");
						ActionTaken = 1;
					end
				else
					if LB_SpellChecker("Drain Mana") and UnitMana("target") > 200 then
						CastSpellByName("Drain Mana");
						LB_PanelFunct("MANA (Drain Mana)");
						ActionTaken = 1;
					end
				end
			elseif LB_SpellChecker("Life Tap") and (UnitHealth("player") / UnitHealthMax("player")) > .25 then
				CastSpellByName("Life Tap");
				LB_PanelFunct("MANA (Life Tap)");
				ActionTaken = 1;
			end
		end
	end
end



function LB_LTAP()
	if LockBoxDebug == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Life Tapping...",0,1,0);
	end
	if UnitExists("target") then
		if (UnitMana("player") / UnitManaMax("player")) < PlayerMana and (UnitHealth("player") / UnitHealthMax("player")) > .25 then
			if LB_SpellChecker("Life Tap") then
				CastSpellByName("Life Tap");
				LB_PanelFunct("LTAP");
				ActionTaken = 1;
			end
		end
	end
end



function LB_WAND()
	if LockBoxDebug == 1 then	
	DEFAULT_CHAT_FRAME:AddMessage("Starting Wand Autocast...",0,1,0);
	end
	if UnitExists("target") then
		CastSpellByName("Shoot");
		LB_PanelFunct("WAND");
		ActionTaken = 1;
	end
end


function LB_CURS()
	LB_CurseSpell = "Curse of "..LB_CurseTbl[LBCurseIndex]
	if LB_SpellChecker(LB_CurseSpell) or LB_DieAction == 1 then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Checking Curse ("..LB_CurseSpell..")...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
		
			if LB_CurseSpell == "Curse of Weakness" then
				if not LB_isWeakness() then 
					LB_castWeakness()
					LB_PanelFunct("CURS (Weakness)");
					ActionTaken = 1;
					return
				end
			elseif  LB_CurseSpell == "Curse of Recklessness" then
				if not LB_isCoR() then 
					LB_castCoR()
					LB_PanelFunct("CURS (Recklessness)");
					ActionTaken = 1;
					return
				end
			elseif  LB_CurseSpell == "Curse of Agony" then
				if not LB_isAgony() then 
					LB_castAgony()
					LB_PanelFunct("CURS (Agony)");
					ActionTaken = 1;
					return
				end			
			elseif  LB_CurseSpell == "Curse of Tongues" then
				if not LB_isCoT() then 
					LB_castCoT()
					LB_PanelFunct("CURS (Tongues)");
					ActionTaken = 1;
					return
				end		
			elseif  LB_CurseSpell == "Curse of Exhaustion" then
				if not LB_isCoEx() then 
					LB_castCoEx()
					LB_PanelFunct("CURS (Exhaustion)");
					ActionTaken = 1;
					return
				end	
			elseif  LB_CurseSpell == "Curse of the Elements" then
				if not LB_isCoE() then 
					LB_castCoE()
					LB_PanelFunct("CURS (Elements)");
					ActionTaken = 1;
					return
				end	
			elseif  LB_CurseSpell == "Curse of Shadow" then
				if not LB_isCoS() then 
					LB_castCoS()
					LB_PanelFunct("CURS (Shadow)");
					ActionTaken = 1;
					return
				end	
			end
		end
	end
end



function LB_MATT()
	if LockBoxDebug == 1 then	
	DEFAULT_CHAT_FRAME:AddMessage("Attacking Target...",0,1,0);
	end
	if UnitExists("target") then
		AttackTarget();
		LB_PanelFunct("MATT");
		ActionTaken = 1;
	end
end



function LB_IMMO()
	if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Checking Immo...",0,1,0);
	end
	if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
		-- check for fireproofness first
		if UnitCreatureType("target") == "Elemental" or UnitCreatureType("target") == "Demon" then
			if LB_Fireproof() then
				return
			end
		end
		if not LB_isImmolate()  then
			CastSpellByName("Immolate");
			LB_PanelFunct("IMMO");
			ActionTaken = 1;
		end
	end
end



function LB_SHBO()
	if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Shooting ShadowBolt...",0,1,0);
	end
	if UnitExists("target") then
		CastSpellByName("Shadow Bolt");
		LB_PanelFunct("SHBO");
		ActionTaken = 1;
	end
end



function LB_COWK()
	if LB_SpellChecker("Curse of Weakness") or LB_DieAction == 1 then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Checking Weakness...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if not LB_isWeakness() then 
				LB_castWeakness()
				LB_PanelFunct("COWK");
				ActionTaken = 1;
			end
		end
	end
end


function LB_CORR()
	if LB_SpellChecker("Corruption") then
		if LockBoxDebug == 1 then	
			DEFAULT_CHAT_FRAME:AddMessage("Checking Corruption...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if not LB_isCorruption() then
				LB_castCorruption()
				LB_PanelFunct("CORR");
				ActionTaken = 1;
			end
		end
	end
end


function LB_COAG()
	if LB_SpellChecker("Curse of Agony") or LB_DieAction == 1 then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Checking Agony...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if not LB_isAgony() then 
				LB_castAgony()
				LB_PanelFunct("COAG");
				ActionTaken = 1;
			end
		end
	end
end


function LB_SOUL()
	if LB_SpellChecker("Drain Soul") then
		if LockBoxDebug == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("Checking Stones...",0,1,0);
		end
		if UnitExists("target") then
			if UnitHealth("target") < DrainSoulLimit and (LB_SoulShards() < ShardCount) then
				if not UnitIsTrivial("target") or UnitPlayerControlled("target") then
					CastSpellByName("Drain Soul");
					LB_PanelFunct("SOUL");
					ActionTaken = 1;
				end
			end
		end
	end
end


function LB_CORK()
	if LB_SpellChecker("Curse of Recklessness") or LB_DieAction == 1 then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Checking Recklessness...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if not LB_isCoR() then 
				LB_castCoR()
				LB_PanelFunct("CORK");
				ActionTaken = 1;
			end
		end
	end
end


function LB_PAIN()
	if LB_SpellChecker("Searing Pain") then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Casting Searing Pain...",0,1,0);
		end
		if UnitCreatureType("target") == "Elemental" or UnitCreatureType("target") == "Demon" then
			if LB_Fireproof() then
				return
			end
		end
		if UnitExists("target") then
			CastSpellByName("Searing Pain");
			LB_PanelFunct("PAIN");
			ActionTaken = 1;
		end
	end
end


function LB_AMPC()
	if LB_SpellChecker("Amplify Curse") then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Casting Amplify Curse...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > AmpCurseLimit then 
		local duration = GetSpellCooldown(ACID, BOOKTYPE_SPELL);
			if duration == 0 then
				CastSpellByName("Amplify Curse");
				LB_PanelFunct("AMPC");
				ActionTaken = 1;
			end
		end
	end
end


function LB_BURN()
	if LB_SpellChecker("Shadowburn") then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Casting Shadowburn...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") < DrainSoulLimit then
			local duration = GetSpellCooldown(ACID, BOOKTYPE_SPELL);
			if duration == 0 then
				CastSpellByName("Shadowburn");
				LB_PanelFunct("BURN");
				ActionTaken = 1;
			end
		end
	end
end



function LB_NTFL()
	if LockBoxDebug == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Checking Nightfall...",0,1,0);
	end
	if UnitExists("target") then
		if LB_isNightFall() then
			CastSpellByName("Shadow Bolt");
			LB_PanelFunct("NTFL");
			ActionTaken = 1;
		end
	end
end



function LB_COTN()
	if LB_SpellChecker("Curse of Tongues") or LB_DieAction == 1 then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Checking Tongues...",0,1,0);
		end
		if (UnitClass("target") =="Warrior" or UnitClass("target") =="Rogue") then
			return
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if not LB_isCoT() then 
				LB_castCoT()
				LB_PanelFunct("COTN");
				ActionTaken = 1;
			end
		end
	end
end


function LB_COEX()
	if LB_SpellChecker("Curse of Exhaustion") or LB_DieAction == 1 then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Checking Exhaustion...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if not LB_isCoEx() then 
				LB_castCoEx()
				LB_PanelFunct("COEX");
				ActionTaken = 1;
			end
		end
	end
end


function LB_COEL()
	if LB_SpellChecker("Curse of the Elements") or LB_DieAction == 1 then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Checking Elements...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if not LB_isCoE() then 
				LB_castCoE()
				LB_PanelFunct("COEL");
				ActionTaken = 1;
			end
		end
	end
end


function LB_CNFL()
	if LB_SpellChecker("Conflagrate") then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Casting Conflagrate...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if LB_isImmolate()  then
				CastSpellByName("Conflagrate");
				LB_PanelFunct("CNFL");
				ActionTaken = 1;
			end
		end
	end
end


function LB_COIL()
	if LB_SpellChecker("Death Coil") then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Casting DeathCoil...",0,1,0);
		end
		local duration = GetSpellCooldown(ACID, BOOKTYPE_SPELL);
		if duration == 0 then
			if UnitHealth("player") < 1000 and UnitHealth("target") > DrainSoulLimit then
				CastSpellByName("Death Coil");
				LB_PanelFunct("COIL");
				ActionTaken = 1;
			end
		end
	end
end


function LB_COSH()
	if LB_SpellChecker("Curse of Shadow") or LB_DieAction == 1 then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Checking Shadow...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if not LB_isCoS() then 
				LB_castCoS()
				LB_PanelFunct("COSH");
				ActionTaken = 1;
			end
		end
	end
end

function LB_FIRE()
	if LB_SpellChecker("Soul Fire") then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Casting Soul Fire...",0,1,0);
		end
		if UnitCreatureType("target") == "Elemental" or UnitCreatureType("target") == "Demon" then
			if LB_Fireproof() then
				return
			end
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			local duration = GetSpellCooldown(ACID, BOOKTYPE_SPELL);
			if duration == 0 then
				CastSpellByName("Soul Fire");
				LB_PanelFunct("FIRE");
				ActionTaken = 1;
			end
		end
	end
end


function LB_TOPS()
	if LockBoxDebug == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Checking Health/Mana...",0,1,0);
	end
	
	--Check for no target AND mana less than 95% and health more than 20% then LifeTap
	if not UnitExists("target") and (UnitMana("player") / UnitManaMax("player")) < 0.95 and (UnitHealth("player") / UnitHealthMax("player")) > 0.25 then
		if LB_SpellChecker("Dark Pact") and UnitMana("pet") > 150 then
			CastSpellByName("Dark Pact");
			LB_PanelFunct("MANA (Dark Pact)");
			ActionTaken = 1;
		elseif LB_SpellChecker("Life Tap") then
			CastSpellByName("Life Tap");
			LB_PanelFunct("TOPS (Life Tap)");
			ActionTaken = 1;
		end
	elseif (UnitHealth("player") / UnitHealthMax("player")) < 0.85 then
		if UnitRace("player") == "Undead" then
		-- NEED A COOLDOWN CHECK IN HERE OTHERWISE WE NEVER ATTEMPT TO USE HS!
			CastSpellByName("Cannibalize")
			ActionTaken = 1
		end
		ActionTaken = 1;
	end
end
	

function LB_SIPH()
	if LB_SpellChecker("Siphon Life") then
		if LockBoxDebug == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("Checking Siphon...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") > DrainSoulLimit then
			if not LB_isSiphonLife() then
				LB_castSiphonLife()
				LB_PanelFunct("SIPH");
				ActionTaken = 1;
			end
		end
	end
end

function LB_PACT()
	if LB_SpellChecker("Dark Pact") then
		if LockBoxDebug == 1 then
			DEFAULT_CHAT_FRAME:AddMessage("Checking Dark Pact...",0,1,0);
		end
		-- if you have a target and your pet has more than 100 mana and you have less than 75% mana
		if UnitExists("target") and UnitMana("pet") > 100 and (UnitMana("player") / UnitManaMax("player")) < .75 then
			CastSpellByName("Dark Pact");
			LB_PanelFunct("PACT");
			ActionTaken = 1;
		end
	end
end



function LB_DIEU()

	if (LB_Humanoid == 1) then
		if (UnitCreatureType("target") ~= "Humanoid" ) and (LB_Humanoid == 1) then
			--DEFAULT_CHAT_FRAME:AddMessage("Not Humanoid",1,0,0);
			return
		else
			--DEFAULT_CHAT_FRAME:AddMessage("Humanoid, COME HERE!",0,1,0);
		end
	end

	if LB_SpellChecker("Curse of Recklessness") then
		if LockBoxDebug == 1 then	
		DEFAULT_CHAT_FRAME:AddMessage("Come to me and die...",0,1,0);
		end
		if UnitExists("target") and UnitHealth("target") < DrainSoulLimit then
			if not LB_isCoR() then 
				CastSpellByName("Curse of Recklessness(Rank 1)")
				LB_PanelFunct("DIEU");
				ActionTaken = 1;
				LB_DieAction = 1
			end
		else
			LB_DieAction = 0
		end
	end
end



function FearKite()
	if LockBoxDebug == 1 then
		DEFAULT_CHAT_FRAME:AddMessage("Go fly a kite!",0,1,0);
	end

 	if not LB_LockTools_checkDebuff("Spell_Shadow_Possession") then
		CastSpellByName("Fear")
		LB_DieAction = 1
	elseif not LB_LockTools_checkDebuff("Spell_Shadow_UnholyStrength") then
		CastSpellByName("Curse of Recklessness(Rank 1)");
	elseif not LB_LockTools_checkDebuff("Spell_Shadow_CurseOfSargeras") then
		CastSpellByName("Curse of Agony(Rank 1)");
	end
end
		
